/***********************************************************************

    This source code is provided as is and may be used to extend 
    the functionality if desired. Do not remove all refernces to the
    original author.

    Ken Schirmeister
    KenSch@MountainCable.net  

***********************************************************************/

// Updater.cpp: implementation of the CUpdater class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DatePrinter.h"
#include "Updater.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CUpdater::CUpdater()
{
    m_iCntDbInfoLines = 0; 
    m_bCurrentMacIsMine = false;
}

//////////////////////////////////////////////////////////////////////

CUpdater::~CUpdater()
{

}

//////////////////////////////////////////////////////////////////////

typedef struct ParaData_t
{
    t_entity ent;
    CUpdater *pThis;
} ParaData_t;

//////////////////////////////////////////////////////////////////////

bool __stdcall CUpdater::FindDateFormatStrings(
        const t_macro *pMac)
{
    bool bRet = false;
    int iLine;
    int iMagic;
    char *pPos;
    char *pLine;
    m_iCntDbInfoLines = 0;
    for ( iLine = 0 , pLine = pMac->info ; iLine < pMac->numl ; iLine++ )
    {
        if ( pPos = strstr(pLine, "Magic:") )
        {
            pPos += 6;  // zeigt jetzt hinter "Magic:"
            iMagic = atoi(pPos);
            if ( iMagic == MY_MAGIC )
            {
                // found one!!!!!
                bRet = true;

                // Die restlichen Zeilen werden als den Text gemerkt:
                char *pDst = m_CurrentDbInfo;
                
                for ( iLine++; iLine < pMac->numl ; iLine++ )
                {
                    pLine += strlen(pLine) + 1;     // zeigt jetzt auf die nchste Zeile
                    strcpy(pDst, pLine);
                    m_iCntDbInfoLines++;
                    pDst += strlen(pDst) + 1;     // zeigt jetzt auf die nchste Zeile
                }
            }
        }
        else
            pLine += strlen(pLine) + 1;     // zeigt jetzt auf die nchste Zeile

    }
    return bRet;
}

//////////////////////////////////////////////////////////////////////

short CUpdater::L_UpdateDates(
        void *para)
{
    ParaData_t *pPara = (ParaData_t *)para;

    if( pPara->ent.type == E_MACRO )
    {
        // gotta remember the DbInfo, if it is one of mine:
        pPara->pThis->m_bCurrentMacIsMine = pPara->pThis->FindDateFormatStrings(&pPara->ent.data.mac);
    }
    else if (pPara->pThis->m_bCurrentMacIsMine )
    {
        ASSERT(pPara->ent.type == E_TXTBLK);

        ushort iLineCnt = 0;
        int iMacroCnt = 0;
        CString strOutput;
        const char *pszLine = pPara->pThis->m_CurrentDbInfo;
        char szNewBlock[16000];
        char *pszNewLine = szNewBlock;

        for ( int i = 0 ; i < pPara->pThis->m_iCntDbInfoLines ; i++ )
        {
            strOutput.Empty();
            iMacroCnt += pPara->pThis->Interpret(pszLine, &strOutput);
            strcpy(pszNewLine, strOutput);
            iLineCnt++;
            pszLine    += strlen(pszLine) + 1;
            pszNewLine += strlen(pszNewLine) + 1;
        }
        if ( iMacroCnt )
        {
            // Wenn berhaupt Text ersetzt wurde, den neuen Text bernehmen;
            pPara->ent.data.txt.str = szNewBlock;
            pPara->ent.data.txt.numl = iLineCnt;
            ExChangeEntity(&pPara->ent, NULL);
            savecount();
        }
    }

    return(CONTINUE_LOOP);
}

//////////////////////////////////////////////////////////////////////

void __stdcall CUpdater::UpdateAllDateMacros()
{
    ParaData_t para;
    para.pThis = this;
    BYTE abData[16000];// Puffer fr variable Daten

    MacroLoop((1 << E_TXTBLK), 0L, 0L, L_UpdateDates, &para, abData, NULL, sizeof(abData));
}
